#!/usr/bin/python
# PixelShip
# A small game programmed for PyWeek2
# By Frem (http://frem.wordpress.com)
# With help from RoeBros, and massive help and support from Treeform. :-D
# Oh, yeah. And all of #pyweek, who answered most of my stupid questions and put up with my random comments. ;-)

# Todo

# - Powerups
# - high scores?

import pygame, random, sys
from pygame.locals import *

#Initialise stuff too basic to go in a function
pygame.init()
screen = pygame.display.set_mode((200, 300))
pygame.display.set_caption('PixelShip')
random.seed()
framerate = pygame.time.Clock()
score = 0

sound_playerlaser = pygame.mixer.Sound("laser.wav")
sound_playerdie = pygame.mixer.Sound("die.wav")
sound_enemylaser = pygame.mixer.Sound("nmefire.wav")
sound_enemydie = pygame.mixer.Sound("nmedie.wav")
sound_powerup = pygame.mixer.Sound("powerup.wav")
 
# Fill background
background = pygame.Surface(screen.get_size())
background = background.convert()
background.fill((0, 0, 0))

def GameOver():
    """Display the GAME OVER screen"""
    highscore = 0

#    f=open('erocshgih', 'r+')
#    highscore = f.read()
#	if score < highscore:
#		highscoreq = 0
#	elif score == highscore:
#		highscoreq = 1
#	elif score > highscore:
#		writescore = ('filescore',score)
#		s = str(writescore)
#		f.write(s)

    f_highscore = int(open('erocshgih').read())
    highscore = f_highscore
    if score > highscore:
	highscore = score
	score_text = font.render("New High Score: %s" % score, 1, (255, 255, 255))
	screen.blit(score_text, (100-30,165) )
	open('erocshgih', 'w').write(str(highscore))
    elif score == highscore:
	score_text = font.render("Matched High Score: %s" % score, 1, (255, 255, 255))
	screen.blit(score_text, (100-70,165) )
    elif score < highscore:
	score_text = font.render("Score: %s" % score, 1, (255, 255, 255))
	screen.blit(score_text, (100-20,165) )
	score_text = font.render("High Score: %s" % highscore, 1, (255, 255, 255))
	screen.blit(score_text, (100-40,180) )

    text = font.render("Game Over", 1, (255, 255, 255))
    textpos = centerx=background.get_width()/2-20, 150
    screen.blit(text, textpos)
    pygame.display.flip()
    pygame.time.wait(1000)
    #while 1:
    while 1:
        pygame.event.pump()
        for event in pygame.event.get():
            if event.type == QUIT:
    	        raise SystemExit()
    	    elif event.type == pygame.KEYDOWN:
		raise SystemExit()
		

class Player(pygame.sprite.Sprite):
    
    def __init__(self):
    
        self.x = 100-8
        self.y = 280
        self.dirx = 0
        self.diry = 0
        self.image = pygame.image.load("ship.png")
        self.rect  = pygame.Rect(self.x,self.y, 16, 16)

    def update(self,steam_level):
        self.x += self.dirx * 0.005 * steam_level
        if (self.x < 0):
                self.x = 0
 
        if (self.x > 200-16):
                self.x= 200-16
                
        self.y += self.diry * 0.005 * steam_level
        if (self.y < 0):
                self.y = 0   
    
        if (self.y > 300-16):
                self.y = 300-16
         
        self.rect =  pygame.Rect(self.x, self.y, 16, 16) #update ship position

        for enomylaser in enomylasers:
             if self.rect.colliderect(enomylaser.rect):
                 sound_playerdie.play(0, 0)
                 pygame.time.wait(1000)
		 score = 0
	         steam_level = 1000
                 GameOver()
        

class Laser(pygame.sprite.Sprite):
    
    def __init__(self, rect = None):
        #pygame.sprite.Sprite.__init__(self) 
        self.image = pygame.image.load("player_laser.png")
        self.rect = rect #pygame.Rect(x, y, 4, 8)
        self.x = rect[0]
        self.y = rect[1]
        self.killme = False

    def update(self):
          
        self.y -= 6
        self.rect =  pygame.Rect(self.x, self.y, 4, 8) #update laser position
     
        if (self.y < 0):
        # off the screen
            self.killme = True

class EvilLaser(pygame.sprite.Sprite):
    """lasers the enemy shoots"""
    def __init__(self, rect = None):
        #pygame.sprite.Sprite.__init__(self) 
        self.image = pygame.image.load("enemy_laser.png")
        self.rect = rect #pygame.Rect(x, y, 8, 8)
        self.x = rect[0]
        self.y = rect[1]
        self.killme = False
	self.laserdir = random.randint(0,3)    
    def update(self):
          
        self.y += 6
	if self.laserdir == 1:
		self.x += 1
	elif self.laserdir == 2:
		self.x -= 1
        self.rect = (self.x, self.y, 8, 8) #update laser position
    
        if (self.y > 300):
            self.killme = True

class Enemy(pygame.sprite.Sprite):
    """An enemy ship"""
    def __init__(self, rect = None):
        #pygame.sprite.Sprite.__init__(self) 
        self.image = pygame.image.load("enemy.png")
        self.rect = rect #pygame.Rect(x, y, 16, 16)
        self.x = rect[0]
        self.y = rect[1]
        self.killme = False
        self.lasered = False

    def update(self):
          
        self.y += 1 
        self.rect =  pygame.Rect(self.x, self.y, 16, 16) #update laser position

        if (self.y > 300-16):
            
            # off the screen
            self.killme = True
      
        #collision detection
        for laser in lasers:
            if self.rect.colliderect(laser.rect):
                laser.killme = True
                self.killme = True
                self.lasered = True
                sound_enemydie.play(0, 0)

                if random.randint(0,2) == 1 : #generate an powerup
		    newpowerup = SteamPowerup(pygame.Rect(self.x, self.y, 4, 8))
		    powerups.append( newpowerup )


        if random.randint(0,40) == 1:
            sound_enemylaser.play(0, 0) #shoot at the player
            #enomylaser = EvilLaser(pygame.Rect(self.x+4, self.y+8, 4, 8))
            #enomylasers.append( enomylaser )
            enomylasers.append( EvilLaser(pygame.Rect(self.x+4, self.y+8, 4, 8)))

##############################################################
class SteamPowerup(pygame.sprite.Sprite):
    
    def __init__(self, rect = None):
        #pygame.sprite.Sprite.__init__(self) 
        self.image = pygame.image.load("powerup.png")
        self.rect = rect #pygame.Rect(x, y, 4, 8)
        self.x = rect[0]
        self.y = rect[1]
        self.killme = False
	self.gotten = True
	self.steamvalue = 0

    def update(self):
          
        self.y += 5
        self.rect =  pygame.Rect(self.x, self.y, 16, 16) #update powerup position
	self.steamvalue += 5
     
        if (self.y < 0):
        # off the screen
            self.killme = True

        if self.rect.colliderect(ship.rect):
	    self.killme = True
	    self.gotten = True
	    sound_enemydie.play(0, 0)
            
# Blit everything to the screen
screen.blit(background, (0, 0))
pygame.display.flip()
 
# Display the steam level
font = pygame.font.Font(None, 14)
text = font.render("Game Over", 1, (255, 255, 255))
textpos = centerx=background.get_width()/2-20, 150
screen.blit(text, textpos)
pygame.event.pump()


ship = Player()

lasers = []
enomys = []
enomylasers = []
powerups = []

steam_level = 1000
score = 0
#posx = 100-8
#posy = 280
#diry = 0
#dirx = 0


#laser_sprite_group = pygame.sprite.Group()

steam_textpos = 5,5

clock = pygame.time.Clock()
# Event loop
while 1:
    for event in pygame.event.get():
        
       pygame.event.pump()
            
       if event.type == QUIT:
            raise SystemExit()

       if event.type == pygame.KEYDOWN:
        pygame.event.pump()
                
        if event.key == K_ESCAPE:
            raise SystemExit()
       
        elif event.key == K_UP:
            ship.diry = -1
                    
        elif event.key == K_DOWN:
            ship.diry = +1
            
        elif event.key == K_LEFT:
            ship.dirx =  -1
            
        elif event.key == K_RIGHT:
            ship.dirx = +1
            
        elif event.key == K_LSHIFT or event.key == K_SPACE :
            sound_playerlaser.play(0, 0)
            
            newlaser = Laser(pygame.Rect(ship.x+6, ship.y, 4, 8))
            lasers.append( newlaser )
        
	#Bad source elf! Don't enable this.
        #elif event.key == K_1:
        #    steam_level = steam_level + 100
        
        #elif event.key == K_2:
        #    steam_level = steam_level - 100

        
       if event.type == pygame.KEYUP:
            pygame.event.pump()
            #keypressed = pygame.key.get_pressed
            if event.key == K_ESCAPE:
                raise SystemExit()
            elif event.key == K_UP:
                ship.diry  = 0
            elif event.key == K_DOWN:
                ship.diry  = 0
            elif event.key == K_RIGHT:
                ship.dirx  = 0
            elif event.key == K_LEFT:
                ship.dirx  = 0

    screen.fill((0,0,0))
    
    ship.update(steam_level)
    screen.blit(ship.image, ship.rect)
    
    if score < 20000:
        if random.randint(0,(40-round(score/500))) == 1 : #generate an enemy
            enomys.append( Enemy(pygame.Rect(random.randint(0,200-16), -16, 16, 16))) 
    elif random.randint(0,10) == 1 : #generate an enemy
        enomys.append( Enemy(pygame.Rect(random.randint(0,200-16), -16, 16, 16)))

    enomyindex = 0
    while enomyindex < len(enomys):
        
        enomy=enomys[enomyindex]
        enomy.update()
        screen.blit(enomy.image, enomy.rect)
        if enomy.killme:
            if enomy.lasered == True:
                score += 100
            del enomys[enomyindex]

        enomyindex+=1

    enomylaserindex = 0
    while enomylaserindex < len(enomylasers):
        
        enomylaser=enomylasers[enomylaserindex]
        enomylaser.update()
        screen.blit(enomylaser.image, enomylaser.rect)
        if enomylaser.killme:
            del enomylasers[enomylaserindex]
            
        enomylaserindex+=1

    laserindex = 0
    while laserindex < len(lasers):
        
        laser=lasers[laserindex]
        laser.update()
        screen.blit(laser.image, laser.rect)
        if laser.killme:
            del lasers[laserindex]
            
        laserindex+=1
    
    ###############################################
    powerupindex = 0
    while powerupindex < len(powerups):
        
        newpowerup = powerups[powerupindex]
        newpowerup.update()
        screen.blit(newpowerup.image, newpowerup.rect)
        if newpowerup.killme:
	    if newpowerup.gotten == True:
		    steam_level += newpowerup.steamvalue
		    sound_powerup.play(0, 0)
            del powerups[powerupindex]
            
        powerupindex+=1
    
    

    steam_text = font.render("Steam: %s" % steam_level, 1, (255, 255, 255))
    screen.blit(steam_text, (5,5))
    
    #if laser > 0:
    #    screen.blit(laser_sprite_group, (laser.rect))
    
    steam_level = steam_level - 1

    score_text = font.render("Score: %s" % score, 1, (255, 255, 255))
    screen.blit(score_text, (5,15) )

    pygame.display.flip()
    
    
    if steam_level <= 0:
	score = 0
	steam_level = 1000
        GameOver()

    framerate.tick(40)


#if __name__ == '__main__': main()

#class player(pygame.sprite.Sprite):
#       """The player's ship"""
#       
#       def ___init___(self):
#              pygame.sprite.Sprite.__init__(self)
#              self.image = pygame.image.load("ship.png")
#              screen = pygame.display.get_surface()
#              self.rect = pygame.Rect(pos, 250, 16, 16)
#              self.rect.x = pos
#              #self.rect.y = pos
#
#       def update():
#              pygame.Rect(pos, 250, 16, 16)
#
#       def moveup(self):
#              self.pos = self.pos
#       def movedown(self):
#              self.pos = self.pos
#       def moveleft(self):
#              self.pos = self.pos -1
#       def moveright(self):
#              self.pos = self.pos +1
#
